CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_Coupons` (
  `id` int(10) NOT NULL auto_increment,
  `status` tinyint(1) NOT NULL default '1',
  `code` varbinary(25) NOT NULL default '',
  `product_id` int(10) NOT NULL default '0',
  `discount_percent` decimal(30,2) NOT NULL default '0.00',
  `discount_price` decimal(30,2) NOT NULL default '0.00',
  `expires` varbinary(10) NOT NULL default '',
  `allowed_uses` smallint(1) NOT NULL default '0',
  `count` smallint(1) NOT NULL default '0',
  `desc` blob NOT NULL,
  `cart_order_id` varbinary(30) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_Downloads` (
  `id` int(11) NOT NULL auto_increment,
  `customerId` int(11) NOT NULL default '0',
  `cart_order_id` varchar(32) NOT NULL default '',
  `noDownloads` int(11) NOT NULL default '0',
  `expire` int(11) NOT NULL default '0',
  `productId` int(11) NOT NULL default '0',
  `accessKey` varchar(10) NOT NULL default '',
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_Modules` (
  `moduleId` int(11) NOT NULL auto_increment,
  `module` varchar(25) NOT NULL default '',
  `folder` varchar(30) NOT NULL default '',
  `status` smallint(1) NOT NULL default '0',
  `default` smallint(1) NOT NULL default '0',
  KEY `moduleId` (`moduleId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


INSERT INTO `@@DB_MAIN_PREFIX@@CubeCart_Modules` VALUES (1,'shipping','Free_Shipping',1,1),(2,'gateway','Print_Order_Form',1,1);

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_SpamBot` (
  `uniqueId` varchar(32) NOT NULL default '',
  `spamCode` varchar(5) NOT NULL default '',
  `userIp` varchar(45) NOT NULL default '',
  `time` int(10) NOT NULL default '0',
  PRIMARY KEY  (`uniqueId`),
  UNIQUE KEY `uniqueId` (`uniqueId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_admin_log` (
  `id` int(11) NOT NULL auto_increment,
  `user` varchar(255) NOT NULL default '',
  `desc` text NOT NULL,
  `time` int(11) NOT NULL default '0',
  `ipAddress` varchar(45) NOT NULL default '',
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_admin_permissions` (
  `permissionId` smallint(6) NOT NULL auto_increment,
  `sectId` smallint(6) NOT NULL default '0',
  `adminId` smallint(6) NOT NULL default '0',
  `read` smallint(6) NOT NULL default '0',
  `write` smallint(6) NOT NULL default '0',
  `edit` smallint(6) NOT NULL default '0',
  `delete` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`permissionId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_admin_sections` (
  `sectId` smallint(6) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL,
  `description` text NOT NULL,
  KEY `sectId` (`sectId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `@@DB_MAIN_PREFIX@@CubeCart_admin_sections` VALUES (1,'users','For the administration of admin users and their permissions.'),(2,'products','For the administration of products.'),(3,'categories','For the administration of categories.'),(4,'documents','For the administration of site documents.'),(5,'customers','For the administration of customers details.'),(6,'shipping','For the administration of shipping methods.'),(7,'filemanager','For the administration of the website images.'),(8,'statistics','This section displays store statistics.'),(9,'settings','For the administration of the code store settings.'),(10,'orders','Access rights for the orders section.'),(11,'offers','Special offers &amp; promotions.'),(12,'reviews','Customer reviews &amp; comments.');

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_admin_sessions` (
  `loginId` int(11) NOT NULL auto_increment,
  `username` varchar(255) NOT NULL default '',
  `time` int(11) NOT NULL default '0',
  `ipAddress` varchar(45) NOT NULL default '',
  `success` int(11) NOT NULL default '0',
  KEY `loginId` (`loginId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_admin_users` (
  `adminId` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `username` varchar(255) NOT NULL default '',
  `password` varchar(32) NOT NULL default '',
  `email` varchar(255) NOT NULL default '',
  `noLogins` int(11) NOT NULL default '0',
  `isSuper` int(11) NOT NULL default '0',
  `notes` text,
  `sessId` varchar(32) default NULL,
  `browser` text,
  `sessIp` varchar(45) default NULL,
  `failLevel` smallint(1) NOT NULL default '0',
  `blockTime` int(10) NOT NULL default '0',
  `lastTime` int(10) NOT NULL default '0',
  KEY `adminId` (`adminId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `@@DB_MAIN_PREFIX@@CubeCart_admin_users` VALUES (1,'@@ADMIN_FULLNAME@@','@@ADMIN_NAME@@','@@ADMIN_PASSWORD@@','@@ADMIN_EMAIL@@',0,1,'This user was setup during installation.',NULL,NULL,NULL,0,0,0);

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_alt_shipping` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL,
  `status` smallint(1) NOT NULL default '0',
  `byprice` smallint(1) NOT NULL,
  `global` smallint(1) NOT NULL,
  `notes` varchar(255) default NULL,
  `order` int(11) default '0',
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_alt_shipping_prices` (
  `id` int(11) NOT NULL auto_increment,
  `alt_ship_id` int(11) NOT NULL,
  `low` decimal(30,2) NOT NULL default '0.00',
  `high` decimal(30,2) NOT NULL default '0.00',
  `price` decimal(30,2) NOT NULL default '0.00',
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_blocker` (
  `id` int(11) NOT NULL auto_increment,
  `browser` text NOT NULL,
  `ip` varchar(45) NOT NULL,
  `username` varchar(50) NOT NULL,
  `blockTime` int(10) NOT NULL default '0',
  `blockLevel` smallint(1) NOT NULL default '0',
  `loc` char(1) NOT NULL,
  `lastTime` int(10) NOT NULL,
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_category` (
  `cat_id` int(16) unsigned NOT NULL auto_increment,
  `cat_name` varchar(100) default NULL,
  `cat_desc` text,
  `cat_father_id` int(16) unsigned NOT NULL default '0',
  `cat_image` varbinary(250) default NULL,
  `per_ship` decimal(20,2) NOT NULL default '0.00',
  `item_ship` decimal(20,2) NOT NULL default '0.00',
  `item_int_ship` decimal(20,2) NOT NULL default '0.00',
  `per_int_ship` decimal(20,2) NOT NULL default '0.00',
  `noProducts` int(11) NOT NULL default '0',
  `hide` tinyint(1) NOT NULL default '0',
  `cat_metatitle` text,
  `cat_metadesc` text,
  `cat_metakeywords` text,
  `seo_custom_url` text,
  `priority` smallint(6) default NULL,
  PRIMARY KEY  (`cat_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `@@DB_MAIN_PREFIX@@CubeCart_category` VALUES (1,'Test Category','This is a test category setup during install. It can be edited or deleted from the store admin control panel.',0,NULL,'0.00','0.00','0.00','0.00',1,0,NULL,NULL,NULL,NULL,1);

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_cats_idx` (
  `id` int(11) NOT NULL auto_increment,
  `cat_id` int(11) NOT NULL default '0',
  `productId` int(11) NOT NULL default '0',
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


INSERT INTO `@@DB_MAIN_PREFIX@@CubeCart_cats_idx` VALUES (1,1,1);

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_cats_lang` (
  `id` int(11) NOT NULL auto_increment,
  `cat_master_id` int(11) NOT NULL default '0',
  `cat_lang` varchar(20) NOT NULL default '',
  `cat_name` varchar(255) NOT NULL default '',
  `cat_desc` text NOT NULL,
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_config` (
  `name` varchar(100) NOT NULL default '',
  `array` text NOT NULL,
  KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `@@DB_MAIN_PREFIX@@CubeCart_config` VALUES ('Free_Shipping','a:1:{s:6:\"status\";s:1:\"1\";}'),('Print_Order_Form','a:16:{s:6:\"status\";s:1:\"1\";s:7:\"default\";s:1:\"1\";s:13:\"multiCurrency\";s:1:\"1\";s:4:\"desc\";s:17:\"Postal Order Form\";s:6:\"cheque\";s:1:\"1\";s:9:\"payableTo\";s:16:\"Company Name Ltd\";s:4:\"card\";s:1:\"1\";s:5:\"cards\";s:35:\"Mastercard,Visa,Switch,Maestro,AMEX\";s:4:\"bank\";s:1:\"1\";s:8:\"bankName\";s:13:\"Your Bank Plc\";s:7:\"accName\";s:12:\"Company Name\";s:8:\"sortCode\";s:8:\"xx-xx-xx\";s:4:\"acNo\";s:8:\"xxxxxxxx\";s:9:\"swiftCode\";s:8:\"xxxxxxxx\";s:7:\"address\";s:70:\"Address Line 1\r\nAddress Line 2\r\nAddress Line 3\r\nAddress Line 4\r\nxxxxxx\";s:5:\"notes\";s:44:\"We can only accept payments in xxx currency.\";}'),('config','a:73:{s:15:\"defaultCurrency\";s:3:\"EUR\";s:11:\"siteCountry\";s:3:\"160\";s:10:\"siteCounty\";s:0:\"\";s:12:\"storeAddress\";s:52:\"Kaiba Corporation,\nStreet,\nTown,\nCounty,\nNORWAY\n1234\";s:10:\"taxCountry\";s:3:\"160\";s:9:\"taxCounty\";s:0:\"\";s:10:\"weightUnit\";s:2:\"Kg\";s:10:\"dateFormat\";s:8:\"l jS F Y\";s:11:\"defaultLang\";s:2:\"en\";s:9:\"dirSymbol\";s:1:\"/\";s:12:\"dnLoadExpire\";s:6:\"172800\";s:11:\"dnLoadTimes\";s:1:\"3\";s:12:\"gdmaxImgSize\";s:3:\"390\";s:9:\"gdquality\";s:2:\"80\";s:11:\"gdthumbSize\";s:2:\"75\";s:10:\"mailMethod\";s:4:\"mail\";s:11:\"masterEmail\";s:16:\"master@email.com\";s:10:\"masterName\";s:17:\"Kaiba Corporation\";s:18:\"maxImageUploadSize\";s:6:\"524288\";s:15:\"metaDescription\";s:29:\"This is the meta description.\";s:12:\"metaKeyWords\";s:29:\"keyword1, keyword2, keyword3.\";s:17:\"noPopularBoxItems\";s:2:\"10\";s:14:\"noSaleBoxItems\";s:2:\"10\";s:18:\"outofstockPurchase\";s:1:\"1\";s:11:\"priceIncTax\";s:1:\"0\";s:12:\"productPages\";s:2:\"10\";s:13:\"productPrecis\";s:3:\"120\";s:11:\"rootRel_SSL\";s:0:\"\";s:8:\"saleMode\";b:1;s:14:\"salePercentOff\";s:2:\"20\";s:15:\"shipAddressLock\";b:0;s:9:\"siteTitle\";s:17:\"Kaiba Corporation\";s:7:\"skinDir\";s:8:\"KitaBlue\";s:16:\"sqlSessionExpiry\";s:6:\"172800\";s:3:\"ssl\";s:1:\"0\";s:10:\"stockLevel\";s:1:\"1\";s:9:\"storeName\";s:17:\"Kaiba Corporation\";s:12:\"storeURL_SSL\";s:0:\"\";s:10:\"timeFormat\";s:18:\"%b %d %Y, %H:%M %p\";s:10:\"timeOffset\";s:1:\"0\";s:11:\"installTime\";i:1205508403;s:7:\"offLine\";s:1:\"0\";s:14:\"offLineContent\";s:76:\"VGhlIHN0b3JlIGlzIGN1cnJlbnRseSBvZmZsaW5lLiBQbGVhc2UgdmlzaXQgYWdhaW4gc29vbi4=\";s:17:\"offLineAllowAdmin\";b:1;s:15:\"showLatestProds\";b:1;s:13:\"noLatestProds\";s:1:\"3\";s:9:\"gdversion\";i:2;s:8:\"cat_tree\";s:1:\"1\";s:11:\"hide_prices\";s:1:\"0\";s:19:\"pop_products_source\";s:1:\"0\";s:5:\"cache\";s:1:\"1\";s:14:\"show_empty_cat\";i:1;s:19:\"disable_alert_email\";i:0;s:13:\"latestNewsRRS\";s:61:\"http://www.cubecart.com/site/forums/index.php?act=rssout&id=1\";s:14:\"richTextEditor\";b:1;s:9:\"rteHeight\";s:3:\"350\";s:13:\"rteHeightUnit\";s:0:\"\";s:17:\"add_to_basket_act\";s:1:\"0\";s:17:\"stock_change_time\";s:1:\"0\";s:18:\"stock_replace_time\";a:5:{i:1;s:1:\"1\";i:2;s:1:\"1\";i:3;s:1:\"1\";i:5;s:1:\"1\";i:6;s:1:\"1\";}s:11:\"orderExpire\";s:7:\"1209600\";s:15:\"stock_warn_type\";s:1:\"0\";s:16:\"stock_warn_level\";s:1:\"5\";s:10:\"changeskin\";s:1:\"0\";s:14:\"priceTaxDelInv\";s:1:\"0\";s:11:\"currecyAuto\";s:1:\"0\";s:5:\"proxy\";s:1:\"0\";s:9:\"proxyHost\";s:0:\"\";s:9:\"proxyPort\";s:0:\"\";s:3:\"sef\";s:1:\"0\";s:7:\"seftags\";s:1:\"0\";s:16:\"sefprodnamefirst\";s:1:\"0\";s:12:\"gdGifSupport\";b:1;}');

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_currencies` (
  `currencyId` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `code` varchar(5) NOT NULL default '',
  `symbolLeft` varbinary(10) default NULL,
  `symbolRight` varbinary(10) default NULL,
  `value` decimal(10,5) NOT NULL default '0.00000',
  `decimalPlaces` int(11) NOT NULL default '0',
  `lastUpdated` int(10) NOT NULL default '0',
  `active` smallint(1) NOT NULL default '0',
  `decimalSymbol` smallint(1) NOT NULL default '0',
  KEY `curencyId` (`currencyId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


INSERT INTO `@@DB_MAIN_PREFIX@@CubeCart_currencies` VALUES (1,'British Pounds','GBP','£','','0.68048',2,1128338492,1,0),(2,'US Dollars','USD','$','','1.19241',2,1128338492,1,0),(3,'Euro','EUR','€','','1.00000',2,1128338492,1,1),(4,'Japanese Yen','JPY','¥','','135.97500',0,1128338492,0,0),(5,'Canadian Dollars','CAD','$','','1.38706',2,1128338492,0,0),(6,'Australian Dollars','AUD','$','','1.56630',2,1128338492,0,0),(7,'Swiss Francs','CHF','CHF','','1.55269',2,1128338492,0,0),(8,'Russian Rubles','RUB','','R','34.15400',0,1128338492,0,0),(9,'Chinese Yuan','CNY','','Yuan','9.64681',2,1128338492,0,0),(10,'South African Rand','ZAR','R','','7.65157',0,1128338492,0,0),(11,'Mexican Peso','MXN','$','','11.05500',2,1128338492,0,0);

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_customer` (
  `email` varchar(50) NOT NULL default '',
  `password` varchar(100) NOT NULL default '',
  `title` varchar(10) default NULL,
  `firstName` varchar(255) NOT NULL default '',
  `lastName` varchar(255) NOT NULL default '',
  `companyName` varchar(150) NOT NULL default '',
  `add_1` varchar(100) NOT NULL default '',
  `add_2` varchar(100) NOT NULL default '',
  `town` varchar(100) NOT NULL default '',
  `county` varchar(100) NOT NULL default '',
  `postcode` varchar(15) NOT NULL default '',
  `country` int(3) NOT NULL,
  `phone` varchar(20) NOT NULL default '',
  `mobile` varchar(50) default NULL,
  `customer_id` int(11) NOT NULL auto_increment,
  `regTime` int(10) NOT NULL default '0',
  `ipAddress` varchar(45) NOT NULL default '',
  `noOrders` int(11) default '0',
  `optIn1st` int(11) NOT NULL default '0',
  `htmlEmail` int(11) NOT NULL default '1',
  `type` int(11) default '0',
  PRIMARY KEY  (`customer_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_docs` (
  `doc_name` varchar(255) NOT NULL default '',
  `doc_content` text NOT NULL,
  `doc_id` int(16) NOT NULL auto_increment,
  `doc_metatitle` text NOT NULL,
  `doc_metadesc` text NOT NULL,
  `doc_metakeywords` text NOT NULL,
  `doc_order` int(11) default '0',
  `doc_terms` smallint(1) default '0',
  `doc_url` text,
  `doc_url_openin` smallint(1) default '0',
  KEY `doc_id` (`doc_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


INSERT INTO `@@DB_MAIN_PREFIX@@CubeCart_docs` VALUES ('About Us','This can be managed under <span class=\"navTitle\">Documents - Site Documents in the admin control panel.<br/>\r\n</span>',1,'','','',1,0,NULL,0),('Contact Us','This can be managed under <span class=\"navTitle\">Documents - Site Documents in the admin control panel.</span><span class=\"navTitle\"/>',2,'','','',2,0,NULL,0),('Terms & Conditions','This can be managed under <span class=\"navTitle\">Documents - Site Documents in the admin control panel.</span>',3,'','','',3,1,NULL,0),('Privacy Policy','This can be managed under <span class=\"navTitle\">Documents - Site Documents in the admin control panel.</span>',4,'','','',4,0,NULL,0);

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_docs_lang` (
  `id` int(11) NOT NULL auto_increment,
  `doc_master_id` int(11) NOT NULL default '0',
  `doc_lang` varchar(20) NOT NULL default '',
  `doc_name` varchar(255) NOT NULL default '',
  `doc_content` text NOT NULL,
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_filemanager` (
  `file_id` int(10) unsigned NOT NULL auto_increment,
  `type` int(1) NOT NULL default '1',
  `disabled` int(1) NOT NULL default '0',
  `filepath` varchar(255) NOT NULL,
  `filename` varchar(255) NOT NULL,
  `filesize` int(11) NOT NULL,
  `mimetype` varchar(50) NOT NULL,
  `md5hash` varchar(32) NOT NULL,
  `description` text NOT NULL,
  PRIMARY KEY  (`file_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_history` (
  `id` int(11) NOT NULL auto_increment,
  `version` varchar(50) NOT NULL,
  `time` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `@@DB_MAIN_PREFIX@@CubeCart_history` VALUES (1,'4.2.0',unix_timestamp());


CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_img_idx` (
  `id` int(11) NOT NULL auto_increment,
  `productId` int(11) NOT NULL default '0',
  `img` varchar(255) NOT NULL default '',
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_inv_lang` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL,
  `prod_lang` varchar(20) NOT NULL,
  `prod_master_id` int(11) NOT NULL default '0',
  `description` text NOT NULL,
  KEY `id` (`id`),
  FULLTEXT KEY `fulltext` (`name`,`description`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_inventory` (
  `productId` int(11) NOT NULL auto_increment,
  `disabled` tinyint(1) NOT NULL default '0',
  `productCode` varchar(60) default NULL,
  `quantity` int(16) NOT NULL default '1',
  `description` text,
  `image` varbinary(250) default NULL,
  `noImages` int(11) NOT NULL default '0',
  `price` decimal(30,2) NOT NULL default '0.00',
  `name` varchar(250) default NULL,
  `cat_id` int(16) NOT NULL default '0',
  `popularity` bigint(64) NOT NULL default '0',
  `sale_price` decimal(30,2) NOT NULL default '0.00',
  `stock_level` int(11) NOT NULL default '0',
  `stockWarn` tinyint(1) NOT NULL default '0',
  `useStockLevel` int(11) NOT NULL default '1',
  `digital` int(11) NOT NULL default '0',
  `digitalDir` varchar(255) default NULL,
  `prodWeight` decimal(10,3) default NULL,
  `taxType` int(11) default NULL,
  `tax_inclusive` tinyint(1) NOT NULL default '0',
  `showFeatured` tinyint(1) unsigned NOT NULL default '1',
  `prod_metatitle` text,
  `prod_metadesc` text,
  `prod_metakeywords` text,
  `eanupcCode` bigint(17) unsigned default NULL,
  `date_added` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `seo_custom_url` text,
  PRIMARY KEY  (`productId`),
  FULLTEXT KEY `fulltext` (`productCode`,`description`,`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


INSERT INTO `@@DB_MAIN_PREFIX@@CubeCart_inventory` VALUES (1,0,'TESA31',1,'This is the main copy for the product.',NULL,0,'10.00','Test Product',1,0,'6.99',0,0,0,0,NULL,'4.000',1,0,1,NULL,NULL,NULL,NULL,'2008-03-14 15:26:45',NULL);


CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_iso_counties` (
  `id` int(11) NOT NULL auto_increment,
  `countryId` smallint(4) NOT NULL default '0',
  `abbrev` varchar(4) NOT NULL default '',
  `name` varchar(40) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


INSERT INTO `@@DB_MAIN_PREFIX@@CubeCart_iso_counties` VALUES (1,226,'AL','Alabama'),(2,226,'AK','Alaska'),(3,226,'AS','American Samoa'),(4,226,'AZ','Arizona'),(5,226,'AR','Arkansas'),(6,226,'AF','Armed Forces Africa'),(7,226,'AA','Armed Forces Americas'),(8,226,'AC','Armed Forces Canada'),(9,226,'AE','Armed Forces Europe'),(10,226,'AM','Armed Forces Middle East'),(11,226,'AP','Armed Forces Pacific'),(12,226,'CA','California'),(13,226,'CO','Colorado'),(14,226,'CT','Connecticut'),(15,226,'DE','Delaware'),(16,226,'DC','District of Columbia'),(17,226,'FM','Federated States Of Micronesia'),(18,226,'FL','Florida'),(19,226,'GA','Georgia'),(20,226,'GU','Guam'),(21,226,'HI','Hawaii'),(22,226,'ID','Idaho'),(23,226,'IL','Illinois'),(24,226,'IN','Indiana'),(25,226,'IA','Iowa'),(26,226,'KS','Kansas'),(27,226,'KY','Kentucky'),(28,226,'LA','Louisiana'),(29,226,'ME','Maine'),(30,226,'MH','Marshall Islands'),(31,226,'MD','Maryland'),(32,226,'MA','Massachusetts'),(33,226,'MI','Michigan'),(34,226,'MN','Minnesota'),(35,226,'MS','Mississippi'),(36,226,'MO','Missouri'),(37,226,'MT','Montana'),(38,226,'NE','Nebraska'),(39,226,'NV','Nevada'),(40,226,'NH','New Hampshire'),(41,226,'NJ','New Jersey'),(42,226,'NM','New Mexico'),(43,226,'NY','New York'),(44,226,'NC','North Carolina'),(45,226,'ND','North Dakota'),(46,226,'MP','Northern Mariana Islands'),(47,226,'OH','Ohio'),(48,226,'OK','Oklahoma'),(49,226,'OR','Oregon'),(50,226,'PW','Palau'),(51,226,'PA','Pennsylvania'),(52,226,'PR','Puerto Rico'),(53,226,'RI','Rhode Island'),(54,226,'SC','South Carolina'),(55,226,'SD','South Dakota'),(56,226,'TN','Tennessee'),(57,226,'TX','Texas'),(58,226,'UT','Utah'),(59,226,'VT','Vermont'),(60,226,'VI','Virgin Islands'),(61,226,'VA','Virginia'),(62,226,'WA','Washington'),(63,226,'WV','West Virginia'),(64,226,'WI','Wisconsin'),(65,226,'WY','Wyoming'),(66,38,'AB','Alberta'),(67,38,'BC','British Columbia'),(68,38,'MB','Manitoba'),(69,38,'NF','Newfoundland'),(70,38,'NB','New Brunswick'),(71,38,'NS','Nova Scotia'),(72,38,'NT','Northwest Territories'),(73,38,'NU','Nunavut'),(74,38,'ON','Ontario'),(75,38,'PE','Prince Edward Island'),(76,38,'QC','Quebec'),(77,38,'SK','Saskatchewan'),(78,38,'YT','Yukon Territory'),(79,80,'NDS','Niedersachsen'),(80,80,'BAW','Baden-WÃ¼rttemberg'),(81,80,'BAY','Bayern'),(82,80,'BER','Berlin'),(83,80,'BRG','Brandenburg'),(84,80,'BRE','Bremen'),(85,80,'HAM','Hamburg'),(86,80,'HES','Hessen'),(87,80,'MEC','Mecklenburg-Vorpommern'),(88,80,'NRW','Nordrhein-Westfalen'),(89,80,'RHE','Rheinland-Pfalz'),(90,80,'SAR','Saarland'),(91,80,'SAS','Sachsen'),(92,80,'SAC','Sachsen-Anhalt'),(93,80,'SCN','Schleswig-Holstein'),(94,80,'THE','ThÃ¼ringen'),(95,14,'WIE','Wien'),(96,14,'NO','NiederÃ–sterreich'),(97,14,'OO','OberÃ–sterreich'),(98,14,'SB','Salzburg'),(99,14,'KN','KÃ¤rnten'),(100,14,'ST','Steiermark'),(101,14,'TI','Tirol'),(102,14,'BL','Burgenland'),(103,14,'VB','Voralberg'),(104,206,'AG','Aargau'),(105,206,'AI','Appenzell Innerrhoden'),(106,206,'APP','Appenzell Ausserrhoden'),(107,206,'BE','Bern'),(108,206,'BLA','Basel-Landschaft'),(109,206,'BS','Basel-Stadt'),(110,206,'FR','Freiburg'),(111,206,'GE','Genf'),(112,206,'GL','Glarus'),(113,206,'JUB','GraubÃ¼nden'),(114,206,'JU','Jura'),(115,206,'LU','Luzern'),(116,206,'NEU','Neuenburg'),(117,206,'NW','Nidwalden'),(118,206,'OW','Obwalden'),(119,206,'SG','St. Gallen'),(120,206,'SH','Schaffhausen'),(121,206,'SO','Solothurn'),(122,206,'SZ','Schwyz'),(123,206,'TG','Thurgau'),(124,206,'TE','Tessin'),(125,206,'UR','Uri'),(126,206,'VD','Waadt'),(127,206,'VS','Wallis'),(128,206,'ZG','Zug'),(129,206,'ZH','ZÃ¼rich'),(130,199,'ACOR','A CoruÃ±a'),(131,199,'ALAV','Alava'),(132,199,'ALBA','Albacete'),(133,199,'ALIC','Alicante'),(134,199,'ALME','Almeria'),(135,199,'ASTU','Asturias'),(136,199,'AVIL','Avila'),(137,199,'BADA','Badajoz'),(138,199,'BALE','Baleares'),(139,199,'BARC','Barcelona'),(140,199,'BURG','Burgos'),(141,199,'CACE','Caceres'),(142,199,'CADI','Cadiz'),(143,199,'CANT','Cantabria'),(144,199,'CAST','Castellon'),(145,199,'CEUT','Ceuta'),(146,199,'CIUD','Ciudad Real'),(147,199,'CORD','Cordoba'),(148,199,'CUEN','Cuenca'),(149,199,'GIRO','Girona'),(150,199,'GRAN','Granada'),(151,199,'GUAD','Guadalajara'),(152,199,'GUIP','Guipuzcoa'),(153,199,'HUEL','Huelva'),(154,199,'HUES','Huesca'),(155,199,'JAEN','Jaen'),(156,199,'LAR','La Rioja'),(157,199,'LAS','Las Palmas'),(158,199,'LEON','Leon'),(159,199,'LLEI','Lleida'),(160,199,'LUGO','Lugo'),(161,199,'MADR','Madrid'),(162,199,'MALA','Malaga'),(163,199,'MELI','Melilla'),(164,199,'MURC','Murcia'),(165,199,'NAVA','Navarra'),(166,199,'OURE','Ourense'),(167,199,'PALE','Palencia'),(168,199,'PONT','Pontevedra'),(169,199,'SALA','Salamanca'),(170,199,'SANT','Santa Cruz de Tenerife'),(171,199,'SEGO','Segovia'),(172,199,'SEVI','Sevilla'),(173,199,'SORI','Soria'),(174,199,'TARR','Tarragona'),(175,199,'TERU','Teruel'),(176,199,'TOLE','Toledo'),(177,199,'VALE','Valencia'),(178,199,'VALL','Valladolid'),(179,199,'VIZC','Vizcaya'),(180,199,'ZAMO','Zamora'),(181,199,'ZARA','Zaragoza'),(415,103,'CW','Carlow'),(416,103,'CN','Cavan'),(417,103,'CE','Clare'),(418,103,'C','Cork'),(419,103,'DL','Donegal'),(420,103,'D','Dublin'),(421,103,'G','Galway'),(422,103,'KY','Kerry'),(423,103,'KE','Kildare'),(424,103,'KK','Kilkenny'),(425,103,'LS','Laoighis'),(426,103,'LM','Leitrim'),(427,103,'LK','Limerick'),(428,103,'LD','Longford'),(429,103,'LH','Louth'),(430,103,'MO','Mayo'),(431,103,'MH','Meath'),(432,103,'MN','Monaghan'),(433,103,'OY','Offaly'),(434,103,'RN','Roscommon'),(435,103,'SO','Sligo'),(436,103,'TA','Tipperary'),(437,103,'WD','Waterford'),(438,103,'WH','Westmeath'),(439,103,'WX','Wexford'),(440,103,'WW','Wicklow'),(441,225,'AVN','Avon'),(442,225,'BDF','Bedfordshire'),(443,225,'BRK','Berkshire'),(444,225,'BKM','Buckinghamshire'),(445,225,'CAM','Cambridgeshire'),(446,225,'CHS','Cheshire'),(447,225,'CLV','Cleveland'),(448,225,'CON','Cornwall'),(449,225,'CUL','Cumberland'),(450,225,'CMA','Cumbria'),(451,225,'DBY','Derbyshire'),(452,225,'DEV','Devon'),(453,225,'DOR','Dorset'),(454,225,'DUR','County Durham'),(455,225,'ESS','Essex'),(456,225,'GLS','Gloucestershire'),(457,225,'HAM','Hampshire'),(458,225,'HWR','Hereford and Worcester'),(459,225,'HEF','Herefordshire'),(460,225,'HRT','Hertfordshire'),(461,225,'HUM','Humberside'),(462,225,'HUN','Huntingdonshire'),(463,225,'IOW','Isle of Wight'),(464,225,'KEN','Kent'),(465,225,'LAN','Lancashire'),(466,225,'LEI','Leicestershire'),(467,225,'LIN','Lincolnshire'),(468,225,'GTM','Greater Manchester'),(469,225,'GTL','Greater London'),(470,225,'MSY','Merseyside'),(471,225,'MDX','Middlesex'),(472,225,'NFK','Norfolk'),(473,225,'NTH','Northamptonshire'),(474,225,'NBL','Northumberland'),(475,225,'NTT','Nottinghamshire'),(476,225,'OXF','Oxfordshire'),(477,225,'RUT','Rutland'),(478,225,'SAL','Shropshire'),(479,225,'SOM','Somerset'),(480,225,'STS','Staffordshire'),(481,225,'SFK','Suffolk'),(482,225,'SRY','Surrey'),(483,225,'SSX','Sussex'),(484,225,'TWR','Tyne and Wear'),(485,225,'WAR','Warwickshire'),(486,225,'WMD','West Midlands'),(487,225,'WES','Westmorland'),(488,225,'WIL','Wiltshire'),(489,225,'WOR','Worcestershire'),(490,225,'YOK','Yorkshire'),(491,225,'ABD','Aberdeenshire'),(492,225,'ANS','Angus'),(493,225,'ARL','Argyll'),(494,225,'AYR','Ayrshire'),(495,225,'BAN','Banffshire'),(496,225,'BEW','Berwickshire'),(497,225,'BUT','Bute'),(498,225,'CAI','Caithness'),(499,225,'CLK','Clackmannanshire'),(500,225,'CRO','Cromartyshire'),(501,225,'DFS','Dumfriesshire'),(502,225,'DNB','Dunbartonshire'),(503,225,'ELN','East Lothian'),(504,225,'FIF','Fife'),(505,225,'INV','Inverness-shire'),(506,225,'KRS','Kinross-shire'),(507,225,'KKD','Kirkcudbrightshire'),(508,225,'LAN','Lanarkshire'),(509,225,'MLN','Midlothian'),(510,225,'MOR','Moray'),(511,225,'NAI','Nairnshire'),(512,225,'OKI','Orkney'),(513,225,'PEE','Peeblesshire'),(514,225,'PER','Perthshire'),(515,225,'RFW','Renfrewshire'),(516,225,'ROC','Ross'),(517,225,'ROX','Roxburghshire'),(518,225,'SEL','Selkirkshire'),(519,225,'SHI','Shetland'),(520,225,'STI','Stirlingshire'),(521,225,'SUT','Sutherland'),(522,225,'WLN','West Lothian'),(523,225,'WIG','Wigtownshire'),(524,225,'AGY','Anglesey'),(525,225,'BRN','Brecknockshire'),(526,225,'CAE','Caernarfonshire'),(527,225,'CAD','Cardiganshire'),(528,225,'CRR','Carmarthenshire'),(529,225,'CLW','Clwyd'),(530,225,'DEN','Denbighshire'),(531,225,'DFD','Dyfed'),(532,225,'FLN','Flintshire'),(533,225,'GLA','Glamorgan'),(534,225,'GNT','Gwent'),(535,225,'GWN','Gwynedd'),(536,225,'MER','Merionethshire'),(537,225,'MON','Monmouthshire'),(538,225,'MGY','Montgomeryshire'),(539,225,'PEM','Pembrokeshire'),(540,225,'POW','Powys'),(541,225,'RAD','Radnorshire'),(542,225,'ANT','Antrim'),(543,225,'ARM','Armagh'),(544,225,'LDY','Londonderry'),(545,225,'DOW','Down'),(546,225,'FER','Fermanagh'),(547,225,'TYR','Tyrone'),(548,150,'DR','Drenthe'),(549,150,'FL','Flevoland'),(550,150,'FR','Friesland'),(551,150,'GLD','Gelderland'),(552,150,'GR','Groningen'),(553,150,'LI','Limburg'),(554,150,'NB','Noord-Brabant'),(555,150,'NH','Noord-Holland'),(556,150,'OV','Overijssel'),(557,150,'UT','Utrecht'),(558,150,'ZL','Zeeland'),(559,150,'ZH','Zuid-Holland'),(560,13,'ACT','Australian Capital Territory'),(561,13,'NSW','New South Wales'),(562,13,'NT','Northern Territory'),(563,13,'QLD','Queensland'),(564,13,'SA','South Australia'),(565,13,'TAS','Tasmania'),(566,13,'VIC','Victoria'),(567,13,'WA','Western Australia');


CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_iso_countries` (
  `id` int(11) NOT NULL auto_increment,
  `iso` char(2) NOT NULL default '',
  `printable_name` varchar(80) NOT NULL default '',
  `iso3` char(3) default NULL,
  `numcode` smallint(6) default NULL,
  PRIMARY KEY  (`iso`),
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


INSERT INTO `@@DB_MAIN_PREFIX@@CubeCart_iso_countries` VALUES (1,'AF','Afghanistan','AFG',4),(2,'AL','Albania','ALB',8),(3,'DZ','Algeria','DZA',12),(4,'AS','American Samoa','ASM',16),(5,'AD','Andorra','AND',20),(6,'AO','Angola','AGO',24),(7,'AI','Anguilla','AIA',660),(8,'AQ','Antarctica',NULL,NULL),(9,'AG','Antigua and Barbuda','ATG',28),(10,'AR','Argentina','ARG',32),(11,'AM','Armenia','ARM',51),(12,'AW','Aruba','ABW',533),(13,'AU','Australia','AUS',36),(14,'AT','Austria','AUT',40),(15,'AZ','Azerbaijan','AZE',31),(16,'BS','Bahamas','BHS',44),(17,'BH','Bahrain','BHR',48),(18,'BD','Bangladesh','BGD',50),(19,'BB','Barbados','BRB',52),(20,'BY','Belarus','BLR',112),(21,'BE','Belgium','BEL',56),(22,'BZ','Belize','BLZ',84),(23,'BJ','Benin','BEN',204),(24,'BM','Bermuda','BMU',60),(25,'BT','Bhutan','BTN',64),(26,'BO','Bolivia','BOL',68),(27,'BA','Bosnia and Herzegovina','BIH',70),(28,'BW','Botswana','BWA',72),(29,'BV','Bouvet Island',NULL,NULL),(30,'BR','Brazil','BRA',76),(31,'IO','British Indian Ocean Territory',NULL,NULL),(32,'BN','Brunei Darussalam','BRN',96),(33,'BG','Bulgaria','BGR',100),(34,'BF','Burkina Faso','BFA',854),(35,'BI','Burundi','BDI',108),(36,'KH','Cambodia','KHM',116),(37,'CM','Cameroon','CMR',120),(38,'CA','Canada','CAN',124),(39,'CV','Cape Verde','CPV',132),(40,'KY','Cayman Islands','CYM',136),(41,'CF','Central African Republic','CAF',140),(42,'TD','Chad','TCD',148),(43,'CL','Chile','CHL',152),(44,'CN','China','CHN',156),(45,'CX','Christmas Island',NULL,NULL),(46,'CC','Cocos (Keeling) Islands',NULL,NULL),(47,'CO','Colombia','COL',170),(48,'KM','Comoros','COM',174),(49,'CG','Congo','COG',178),(50,'CD','Congo, the Democratic Republic of the','COD',180),(51,'CK','Cook Islands','COK',184),(52,'CR','Costa Rica','CRI',188),(53,'CI','Cote D\'Ivoire','CIV',384),(54,'HR','Croatia','HRV',191),(55,'CU','Cuba','CUB',192),(56,'CY','Cyprus','CYP',196),(57,'CZ','Czech Republic','CZE',203),(58,'DK','Denmark','DNK',208),(59,'DJ','Djibouti','DJI',262),(60,'DM','Dominica','DMA',212),(61,'DO','Dominican Republic','DOM',214),(62,'EC','Ecuador','ECU',218),(63,'EG','Egypt','EGY',818),(64,'SV','El Salvador','SLV',222),(65,'GQ','Equatorial Guinea','GNQ',226),(66,'ER','Eritrea','ERI',232),(67,'EE','Estonia','EST',233),(68,'ET','Ethiopia','ETH',231),(69,'FK','Falkland Islands (Malvinas)','FLK',238),(70,'FO','Faroe Islands','FRO',234),(71,'FJ','Fiji','FJI',242),(72,'FI','Finland','FIN',246),(73,'FR','France','FRA',250),(74,'GF','French Guiana','GUF',254),(75,'PF','French Polynesia','PYF',258),(76,'TF','French Southern Territories',NULL,NULL),(77,'GA','Gabon','GAB',266),(78,'GM','Gambia','GMB',270),(79,'GE','Georgia','GEO',268),(80,'DE','Germany','DEU',276),(81,'GH','Ghana','GHA',288),(82,'GI','Gibraltar','GIB',292),(83,'GR','Greece','GRC',300),(84,'GL','Greenland','GRL',304),(85,'GD','Grenada','GRD',308),(86,'GP','Guadeloupe','GLP',312),(87,'GU','Guam','GUM',316),(88,'GT','Guatemala','GTM',320),(89,'GN','Guinea','GIN',324),(90,'GW','Guinea-Bissau','GNB',624),(91,'GY','Guyana','GUY',328),(92,'HT','Haiti','HTI',332),(93,'HM','Heard Island and Mcdonald Islands',NULL,NULL),(94,'VA','Holy See (Vatican City State)','VAT',336),(95,'HN','Honduras','HND',340),(96,'HK','Hong Kong','HKG',344),(97,'HU','Hungary','HUN',348),(98,'IS','Iceland','ISL',352),(99,'IN','India','IND',356),(100,'ID','Indonesia','IDN',360),(101,'IR','Iran, Islamic Republic of','IRN',364),(102,'IQ','Iraq','IRQ',368),(103,'IE','Ireland','IRL',372),(104,'IL','Israel','ISR',376),(105,'IT','Italy','ITA',380),(106,'JM','Jamaica','JAM',388),(107,'JP','Japan','JPN',392),(108,'JO','Jordan','JOR',400),(109,'KZ','Kazakhstan','KAZ',398),(110,'KE','Kenya','KEN',404),(111,'KI','Kiribati','KIR',296),(112,'KP','Korea, Democratic People\'s Republic of','PRK',408),(113,'KR','Korea, Republic of','KOR',410),(114,'KW','Kuwait','KWT',414),(115,'KG','Kyrgyzstan','KGZ',417),(116,'LA','Lao People\'s Democratic Republic','LAO',418),(117,'LV','Latvia','LVA',428),(118,'LB','Lebanon','LBN',422),(119,'LS','Lesotho','LSO',426),(120,'LR','Liberia','LBR',430),(121,'LY','Libyan Arab Jamahiriya','LBY',434),(122,'LI','Liechtenstein','LIE',438),(123,'LT','Lithuania','LTU',440),(124,'LU','Luxembourg','LUX',442),(125,'MO','Macao','MAC',446),(126,'MK','Macedonia, the Former Yugoslav Republic of','MKD',807),(127,'MG','Madagascar','MDG',450),(128,'MW','Malawi','MWI',454),(129,'MY','Malaysia','MYS',458),(130,'MV','Maldives','MDV',462),(131,'ML','Mali','MLI',466),(132,'MT','Malta','MLT',470),(133,'MH','Marshall Islands','MHL',584),(134,'MQ','Martinique','MTQ',474),(135,'MR','Mauritania','MRT',478),(136,'MU','Mauritius','MUS',480),(137,'YT','Mayotte',NULL,NULL),(138,'MX','Mexico','MEX',484),(139,'FM','Micronesia, Federated States of','FSM',583),(140,'MD','Moldova, Republic of','MDA',498),(141,'MC','Monaco','MCO',492),(142,'MN','Mongolia','MNG',496),(143,'MS','Montserrat','MSR',500),(144,'MA','Morocco','MAR',504),(145,'MZ','Mozambique','MOZ',508),(146,'MM','Myanmar','MMR',104),(147,'NA','Namibia','NAM',516),(148,'NR','Nauru','NRU',520),(149,'NP','Nepal','NPL',524),(150,'NL','Netherlands','NLD',528),(151,'AN','Netherlands Antilles','ANT',530),(152,'NC','New Caledonia','NCL',540),(153,'NZ','New Zealand','NZL',554),(154,'NI','Nicaragua','NIC',558),(155,'NE','Niger','NER',562),(156,'NG','Nigeria','NGA',566),(157,'NU','Niue','NIU',570),(158,'NF','Norfolk Island','NFK',574),(159,'MP','Northern Mariana Islands','MNP',580),(160,'NO','Norway','NOR',578),(161,'OM','Oman','OMN',512),(162,'PK','Pakistan','PAK',586),(163,'PW','Palau','PLW',585),(164,'PS','Palestinian Territory, Occupied',NULL,NULL),(165,'PA','Panama','PAN',591),(166,'PG','Papua New Guinea','PNG',598),(167,'PY','Paraguay','PRY',600),(168,'PE','Peru','PER',604),(169,'PH','Philippines','PHL',608),(170,'PN','Pitcairn','PCN',612),(171,'PL','Poland','POL',616),(172,'PT','Portugal','PRT',620),(173,'PR','Puerto Rico','PRI',630),(174,'QA','Qatar','QAT',634),(175,'RE','Reunion','REU',638),(176,'RO','Romania','ROM',642),(177,'RU','Russian Federation','RUS',643),(178,'RW','Rwanda','RWA',646),(179,'SH','Saint Helena','SHN',654),(180,'KN','Saint Kitts and Nevis','KNA',659),(181,'LC','Saint Lucia','LCA',662),(182,'PM','Saint Pierre and Miquelon','SPM',666),(183,'VC','Saint Vincent and the Grenadines','VCT',670),(184,'WS','Samoa','WSM',882),(185,'SM','San Marino','SMR',674),(186,'ST','Sao Tome and Principe','STP',678),(187,'SA','Saudi Arabia','SAU',682),(188,'SN','Senegal','SEN',686),(189,'RS','Serbia',NULL,NULL),(190,'SC','Seychelles','SYC',690),(191,'SL','Sierra Leone','SLE',694),(192,'SG','Singapore','SGP',702),(193,'SK','Slovakia','SVK',703),(194,'SI','Slovenia','SVN',705),(195,'SB','Solomon Islands','SLB',90),(196,'SO','Somalia','SOM',706),(197,'ZA','South Africa','ZAF',710),(198,'GS','South Georgia and the South Sandwich Islands',NULL,NULL),(199,'ES','Spain','ESP',724),(200,'LK','Sri Lanka','LKA',144),(201,'SD','Sudan','SDN',736),(202,'SR','Suriname','SUR',740),(203,'SJ','Svalbard and Jan Mayen','SJM',744),(204,'SZ','Swaziland','SWZ',748),(205,'SE','Sweden','SWE',752),(206,'CH','Switzerland','CHE',756),(207,'SY','Syrian Arab Republic','SYR',760),(208,'TW','Taiwan','TWN',158),(209,'TJ','Tajikistan','TJK',762),(210,'TZ','Tanzania, United Republic of','TZA',834),(211,'TH','Thailand','THA',764),(212,'TL','Timor-Leste',NULL,NULL),(213,'TG','Togo','TGO',768),(214,'TK','Tokelau','TKL',772),(215,'TO','Tonga','TON',776),(216,'TT','Trinidad and Tobago','TTO',780),(217,'TN','Tunisia','TUN',788),(218,'TR','Turkey','TUR',792),(219,'TM','Turkmenistan','TKM',795),(220,'TC','Turks and Caicos Islands','TCA',796),(221,'TV','Tuvalu','TUV',798),(222,'UG','Uganda','UGA',800),(223,'UA','Ukraine','UKR',804),(224,'AE','United Arab Emirates','ARE',784),(225,'GB','United Kingdom','GBR',826),(226,'US','United States','USA',840),(227,'UM','United States Minor Outlying Islands',NULL,NULL),(228,'UY','Uruguay','URY',858),(229,'UZ','Uzbekistan','UZB',860),(230,'VU','Vanuatu','VUT',548),(231,'VE','Venezuela','VEN',862),(232,'VN','Viet Nam','VNM',704),(233,'VG','Virgin Islands, British','VGB',92),(234,'VI','Virgin Islands, U.s.','VIR',850),(235,'WF','Wallis and Futuna','WLF',876),(236,'EH','Western Sahara','ESH',732),(237,'YE','Yemen','YEM',887),(238,'ZM','Zambia','ZMB',894),(239,'ZW','Zimbabwe','ZWE',716),(240,'ME','Montenegro',NULL,NULL);


CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_lang` (
  `identifier` varchar(50) NOT NULL default '',
  `langArray` longtext NOT NULL,
  UNIQUE KEY `identifier` (`identifier`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_options_bot` (
  `assign_id` int(32) NOT NULL auto_increment,
  `product` int(11) NOT NULL default '0',
  `option_id` int(32) NOT NULL default '0',
  `value_id` int(32) NOT NULL default '0',
  `option_price` decimal(30,2) NOT NULL default '0.00',
  `option_symbol` char(1) NOT NULL default '',
  PRIMARY KEY  (`assign_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_options_mid` (
  `value_id` int(16) NOT NULL auto_increment,
  `value_name` varchar(30) NOT NULL default '',
  `father_id` int(16) NOT NULL default '0',
  PRIMARY KEY  (`value_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_options_top` (
  `option_id` int(16) NOT NULL auto_increment,
  `option_name` varchar(30) NOT NULL default '',
  `option_type` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`option_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_order_inv` (
  `productId` int(11) NOT NULL default '0',
  `productCode` varchar(255) NOT NULL default '',
  `name` varchar(225) NOT NULL default '',
  `quantity` smallint(4) NOT NULL default '0',
  `price` decimal(30,2) NOT NULL default '0.00',
  `cart_order_id` varchar(30) NOT NULL default '',
  `id` int(32) NOT NULL auto_increment,
  `product_options` text NOT NULL,
  `digital` smallint(1) NOT NULL default '0',
  `stockUpdated` int(11) NOT NULL default '0',
  `custom` text NOT NULL,
  `couponId` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_order_sum` (
  `cart_order_id` varchar(30) NOT NULL,
  `customer_id` int(11) NOT NULL default '0',
  `name` varchar(225) default NULL,
  `add_1` varchar(225) default NULL,
  `add_2` varchar(225) default NULL,
  `town` varchar(225) default NULL,
  `county` varchar(225) default NULL,
  `postcode` varchar(225) default NULL,
  `country` varchar(225) default NULL,
  `name_d` varchar(225) default NULL,
  `add_1_d` varchar(225) default NULL,
  `add_2_d` varchar(225) default NULL,
  `town_d` varchar(225) default NULL,
  `county_d` varchar(225) default NULL,
  `postcode_d` varchar(225) default NULL,
  `country_d` varchar(225) default NULL,
  `phone` varchar(225) default NULL,
  `mobile` varchar(255) default NULL,
  `subtotal` decimal(30,2) NOT NULL default '0.00',
  `discount` decimal(30,2) NOT NULL default '0.00',
  `prod_total` decimal(30,2) NOT NULL default '0.00',
  `total_tax` decimal(30,2) NOT NULL default '0.00',
  `total_ship` decimal(30,2) NOT NULL default '0.00',
  `status` int(16) NOT NULL default '1',
  `sec_order_id` varchar(30) default NULL,
  `ip` varchar(45) NOT NULL default '0.0.0.0',
  `time` int(10) NOT NULL default '0',
  `email` varchar(225) NOT NULL,
  `comments` text,
  `ship_date` varchar(50) default NULL,
  `shipMethod` varchar(255) default NULL,
  `gateway` varchar(50) NOT NULL,
  `currency` varchar(5) NOT NULL,
  `customer_comments` text,
  `extra_notes` text NOT NULL,
  `tax1_disp` varchar(128) default NULL,
  `tax1_amt` decimal(30,2) NOT NULL default '0.00',
  `tax2_disp` varchar(128) default NULL,
  `tax2_amt` decimal(30,2) NOT NULL default '0.00',
  `tax3_disp` varchar(128) default NULL,
  `tax3_amt` decimal(30,2) NOT NULL default '0.00',
  `offline_capture` blob,
  `courier_tracking` text,
  `companyName` varchar(150) default NULL,
  `companyName_d` varchar(150) default NULL,
  `basket` text,
  PRIMARY KEY  (`cart_order_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_reviews` (
  `id` int(11) NOT NULL auto_increment,
  `approved` smallint(1) NOT NULL default '0',
  `productId` int(11) NOT NULL,
  `type` smallint(1) NOT NULL,
  `rating` smallint(1) NOT NULL,
  `name` varchar(255) NOT NULL,
  `email` varchar(255) NOT NULL,
  `title` varchar(255) NOT NULL,
  `review` text NOT NULL,
  `ip` varchar(45) NOT NULL,
  `time` int(10) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_search` (
  `searchstr` varchar(255) NOT NULL default '',
  `hits` bigint(64) NOT NULL default '0',
  `id` bigint(64) NOT NULL auto_increment,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_sessions` (
  `sessId` varchar(32) NOT NULL default '',
  `basket` text,
  `timeStart` int(11) NOT NULL default '0',
  `timeLast` int(11) NOT NULL default '0',
  `customer_id` int(11) NOT NULL default '0',
  `location` varchar(255) default NULL,
  `lang` varchar(20) default NULL,
  `currency` char(3) default NULL,
  `skin` varchar(25) default NULL,
  `ip` varchar(45) default NULL,
  `browser` text NOT NULL,
  PRIMARY KEY  (`sessId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_tax_details` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(128) NOT NULL default '',
  `display` varchar(128) NOT NULL default '',
  `reg_number` varchar(128) NOT NULL default '',
  `status` smallint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_tax_rates` (
  `id` int(11) NOT NULL auto_increment,
  `type_id` int(11) NOT NULL default '1',
  `details_id` int(11) NOT NULL default '0',
  `country_id` int(11) NOT NULL default '0',
  `county_id` int(11) NOT NULL default '0',
  `tax_percent` decimal(7,4) NOT NULL default '0.0000',
  `goods` int(11) NOT NULL default '0',
  `shipping` int(11) NOT NULL default '0',
  `active` smallint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `type_id` (`type_id`,`details_id`,`country_id`,`county_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_taxes` (
  `id` int(11) NOT NULL auto_increment,
  `taxName` varchar(50) NOT NULL default '',
  `percent` decimal(7,4) NOT NULL default '0.0000',
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `@@DB_MAIN_PREFIX@@CubeCart_taxes` VALUES (1,'Standard Tax','19.0000'),(2,'Tax Exempt','0.0000');

CREATE TABLE `@@DB_MAIN_PREFIX@@CubeCart_transactions` (
  `id` int(11) NOT NULL auto_increment,
  `gateway` varchar(255) default NULL,
  `extra` varchar(255) default NULL,
  `status` varchar(50) default NULL,
  `customer_id` int(11) default NULL,
  `order_id` varchar(255) default NULL,
  `trans_id` varchar(50) default NULL,
  `time` int(10) default NULL,
  `amount` decimal(30,2) default NULL,
  `remainder` decimal(30,2) NOT NULL default '0.00',
  `notes` text,
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;